*** rasmol.c	2005/01/16 20:24:05	1.2
--- rasmol.c	2005/01/16 20:25:17
***************
*** 1046,1051 ****
--- 1052,1058 ----
                                  DisableWireframe();
                                  SetRibbonStatus(False,0,0);
                                  DisableBackbone();
+                                 DrawSurf = False;
                                  ReDrawFlag |= RFRefresh;
                                  break;
  
***************
*** 1079,1084 ****
--- 1086,1103 ----
                                  SetRibbonCartoons();
                                  DisableBackbone();
                                  ReDrawFlag |= RFRefresh;
+                                 break;
+ 
+                       case(9):  /* MolSurf */
+                                 DrawSurf = True;
+                                 ProbeRadius = 350;
+                                 SetVanWaalRadius(SphereFlag | TouchFlag);
+                                 DisableWireframe();
+                                 SetRibbonStatus(False,0,0);
+                                 DisableBackbone();
+                                 CreateSurfaceBonds();
+                                 ReDrawFlag |= RFRefresh;
+                                 break;
                    }
                    break;
  
***************
*** 1481,1486 ****
--- 1500,1506 ----
      ProfCount = 0;
  
      CalcBondsFlag = True;
+     CalcSurfFlag = False;
      LabelOptFlag = False;
      FileFormat = FormatPDB;
      AllowWrite = False;
*** rastxt.c	2004/05/07 19:46:16	1.1
--- rastxt.c	2005/01/16 20:25:17
***************
*** 413,424 ****
  {
      register int i;
  
!     for( i=0; i<8; i++ )
          DialValue[i] = 0.0;
      
      XRange = x;   WRange = XRange>>1;
      YRange = y;   HRange = YRange>>1;
      Range = MinFun(XRange,YRange);
      
      /* Initialise Palette! */
      for( i=0; i<256; i++ )
--- 413,425 ----
  {
      register int i;
  
!     for( i=0; i<10; i++ )
          DialValue[i] = 0.0;
      
      XRange = x;   WRange = XRange>>1;
      YRange = y;   HRange = YRange>>1;
      Range = MinFun(XRange,YRange);
+     ZRange = 20000;
      
      /* Initialise Palette! */
      for( i=0; i<256; i++ )
***************
*** 495,500 ****
--- 496,502 ----
  
      FileFormat = FormatPDB;
      CalcBondsFlag = True;
+     CalcSurfFlag = False;
  }
  
  
*** raswin.c	2004/05/07 19:46:16	1.1
--- raswin.c	2005/01/16 20:25:17
***************
*** 1983,1988 ****
--- 1989,2007 ----
  			      ReDrawFlag |= RFRefresh;
  			      break;
  
+ 	case(IDM_MOLSURF):    /* Molecular Surface */
+ 			      DrawSurf = True;
+ 			      ProbeRadius = 350;
+ 			      SetVanWaalRadius( SphereFlag | TouchFlag );
+ 			      DisableWireframe();
+ 			      SetRibbonStatus(False,0,0);
+ 			      DisableBackbone();
+ 			      CreateSurfaceBonds();
+ 			      ReDrawFlag |= RFRefresh;
+ 			      break;
+ 
+ 
+ 
  	/* Colours Menu */
  	case(IDM_MONO):     MonoColourAttrib(255,255,255);
  			    ReDrawFlag |= RFColour;  break;
***************
*** 2934,2939 ****
--- 2953,2959 ----
      snamebuf[0] = '\0';
  
      CalcBondsFlag = True;
+     CalcSurfFlag = False;
      LabelOptFlag = False;
      FileFormat = FormatPDB;
      AllowWrite = False;
*** render.c	2004/05/07 19:46:16	1.1
--- render.c	2005/01/16 20:25:17
***************
*** 155,179 ****
  
  #define PoolSize       16
  #define ApproxZero     1.0E-3
- #define RootSix        2.44948974278
  #define INFINITY       200000
  #define FUDGEFACTOR    1000
  
- #ifdef INVERT
- #define InvertY(y) (y)
- #define ProperY(y) (-y)
- #else
- #define InvertY(y) (-(y))
- #define ProperY(y) (y)
- #endif
- 
- 
- /* These define light source position */
- #define LightDot(x,y,z)  ((x)+(y)+(z)+(z))
- #define LightLength      RootSix
- #define LightXComp       1
- #define LightYComp       1
- #define LightZComp       2
  
  
  /* Macros for commonly used loops */
--- 121,129 ----
***************
*** 181,186 ****
--- 131,137 ----
                       for(group=chain->glist;group;group=group->gnext)    \
                       for(aptr=group->alist;aptr;aptr=aptr->anext)
  #define ForEachBond  for(bptr=Database->blist;bptr;bptr=bptr->bnext)
+ #define ForEachSurfBond  for(sbptr=Database->sblist;sbptr;sbptr=sbptr->sbnext)
  #define ForEachBack  for(chain=Database->clist;chain;chain=chain->cnext) \
                       for(bptr=chain->blist;bptr;bptr=bptr->bnext)
  
***************
*** 446,460 ****
      register int index;
      register long len, temp;
  
-     temp = (long)XRange*YRange*sizeof(short)+32;
  #ifdef MSWIN
      if( DBufHandle ) GlobalFree(DBufHandle);
      DBufHandle = GlobalAlloc(GMEM_MOVEABLE,temp);
      if( !DBufHandle ) FatalRenderError("depth buffer");
  #else
      if( DBuffer ) _ffree( DBuffer );
      DBuffer = (short*)_fmalloc( temp );
      if( !DBuffer ) FatalRenderError("depth buffer");
  #endif
      DBClear=False;
  
--- 397,413 ----
      register int index;
      register long len, temp;
  
  #ifdef MSWIN
+     temp = (long)XRange*YRange*sizeof(short)+32;
      if( DBufHandle ) GlobalFree(DBufHandle);
      DBufHandle = GlobalAlloc(GMEM_MOVEABLE,temp);
      if( !DBufHandle ) FatalRenderError("depth buffer");
  #else
+     temp = (long)XRange*YRange*sizeof(short)+32;
      if( DBuffer ) _ffree( DBuffer );
      DBuffer = (short*)_fmalloc( temp );
      if( !DBuffer ) FatalRenderError("depth buffer");
+     temp = (long)XRange*YRange*sizeof(int)+32;
  #endif
      DBClear=False;
  
***************
*** 542,551 ****
      for( scan=0; scan<BuckY; scan++ )
  	*temp++ = (void __far*)0;
  
      if( UseClipping )
      {   ForEachAtom
! 	    if( aptr->flag&SphereFlag )
  	    {   rad = aptr->irad;
  		if( (aptr->x-rad>=XRange) || 
  		    (aptr->x+rad<0) || (aptr->y+rad<0) )
  		    continue;
--- 495,507 ----
      for( scan=0; scan<BuckY; scan++ )
  	*temp++ = (void __far*)0;
  
+     iProbeRad = (int)rint(Scale*ProbeRadius);
+ 
      if( UseClipping )
      {   ForEachAtom
! 	    if( aptr->flag&(SphereFlag|TouchFlag) )
  	    {   rad = aptr->irad;
+                 if (aptr->flag&ExpandFlag) rad += iProbeRad;
  		if( (aptr->x-rad>=XRange) || 
  		    (aptr->x+rad<0) || (aptr->y+rad<0) )
  		    continue;
***************
*** 561,568 ****
  	    }
      } else
  	ForEachAtom
! 	    if( aptr->flag&SphereFlag )
  	    {   scan = aptr->y-aptr->irad;
  		aptr->bucket = YBucket[scan];
  		YBucket[scan] = aptr;
  	    }
--- 517,525 ----
  	    }
      } else
  	ForEachAtom
! 	    if( aptr->flag&(SphereFlag|TouchFlag) )
  	    {   scan = aptr->y-aptr->irad;
+                 if (aptr->flag&ExpandFlag) scan -= iProbeRad;
  		aptr->bucket = YBucket[scan];
  		YBucket[scan] = aptr;
  	    }
***************
*** 667,674 ****
  	if( flag != SphereFlag )
  	{   if( SolventDots || !ProbeRadius )
  	    {   rad = ElemVDWRadius(aptr->elemno);
! 	    } else rad = ProbeRadius;
! 	} else rad = aptr->radius;  
  	radius2 = (Long)rad*rad;
  
  	lvx = (int)((mx-rad)*IVoxRatio);  hvx = (int)((mx+rad)*IVoxRatio);
--- 624,632 ----
  	if( flag != SphereFlag )
  	{   if( SolventDots || !ProbeRadius )
  	    {   rad = ElemVDWRadius(aptr->elemno);
! 	    } else rad = ElemVDWRadius(aptr->elemno)+ProbeRadius;
! 	} else rad = aptr->radius +
!             (aptr->flag&ExpandFlag)?ProbeRadius:0;  
  	radius2 = (Long)rad*rad;
  
  	lvx = (int)((mx-rad)*IVoxRatio);  hvx = (int)((mx+rad)*IVoxRatio);
***************
*** 852,858 ****
      register short __huge *dbase;
      register short __huge *dptr;
      register Pixel __huge *fptr;
-     register Byte __far *tptr;
  
      register int pos,depth,inten;
      register int lastx,wide,scan;
--- 810,815 ----
***************
*** 875,891 ****
  	prev = &list;
  	for( ptr=list; ptr; ptr=ptr->next )
  	{   dy = scan - ptr->y;
! 	    wide = LookUp[ptr->irad][AbsFun(dy)];
  	    lastx = (XRange-1)-ptr->x;
  	    if( wide<lastx ) lastx=wide;
  	    dx = - MinFun(wide,ptr->x);
  
  	    iptr = IBuffer+ptr->x;
- 	    tptr = LookUp[wide];
  
  	    dptr = dbase+ptr->x+dx;
  	    while( dx<=lastx )
! 	    {   depth = tptr[AbsFun(dx)]+ptr->z;
  		UpdateScanAcross;
  	    }
  
--- 832,847 ----
  	prev = &list;
  	for( ptr=list; ptr; ptr=ptr->next )
  	{   dy = scan - ptr->y;
! 	    wide = pythag(ptr->irad,AbsFun(dy));
  	    lastx = (XRange-1)-ptr->x;
  	    if( wide<lastx ) lastx=wide;
  	    dx = - MinFun(wide,ptr->x);
  
  	    iptr = IBuffer+ptr->x;
  
  	    dptr = dbase+ptr->x+dx;
  	    while( dx<=lastx )
! 	    {   depth = pythag(wide,AbsFun(dx))+ptr->z;
  		UpdateScanAcross;
  	    }
  
***************
*** 937,1006 ****
      register Group __far *group;
      register RAtom __far *aptr;
  
      if( UseShadow )
      {   if( !BucketFlag )
  	    PrepareYBucket();
  	ScanLine();
      } else if( UseClipping )
      {   ForEachAtom
! 	    if( aptr->flag&SphereFlag )
! 		ClipSphere(aptr->x,aptr->y,aptr->z,aptr->irad,aptr->col);
      } else 
  	ForEachAtom
! 	    if( aptr->flag&SphereFlag )
! 		DrawSphere(aptr->x,aptr->y,aptr->z,aptr->irad,aptr->col);
  }
  
  static void DisplayStars( void )
  {
      register Chain __far *chain;
      register Group __far *group;
      register RAtom __far *aptr;
  
      if( UseClipping )
      {   ForEachAtom
  	    if( aptr->flag&StarFlag )
! 		ClipStar(aptr->x,aptr->y,aptr->z,aptr->radius,aptr->col);
      } else 
  	ForEachAtom
  	    if( aptr->flag&StarFlag )
! 		DrawStar(aptr->x,aptr->y,aptr->z,aptr->radius,aptr->col);
  }
  
  
  static void DisplayWireframe( void )
  {
      register Bond __far *bptr;
      register RAtom __far *s;
      register RAtom __far *d;
!     register int sc,dc;
  
      if( UseClipping )
      {   ForEachBond
  	   if( bptr->flag & DrawBondFlag )
             {   s = bptr->srcatom; d = bptr->dstatom;
! 	       if( !bptr->col ) 
! 	       {   sc = s->col;  dc = d->col;
! 	       } else sc = dc = bptr->col;
  
  	       if( bptr->flag&WireFlag )
  	       {   ClipTwinVector(s->x,s->y,s->z,d->x,d->y,d->z,sc,dc,bptr->altl);
  	       } else if( bptr->flag&CylinderFlag )
  	       {   if( bptr->irad>0 )
  	           {  ClipCylinder(s->x,s->y,s->z,d->x,d->y,d->z,
!                                    sc,dc,bptr->irad, bptr->altl,bptr->iarad);
  	           } else ClipTwinLine(s->x,s->y,s->z,d->x,d->y,d->z,
  				   sc+ColourMask,dc+ColourMask,bptr->altl);
                 } else /* bptr->flag & DashFlag */
                     ClipDashVector(s->x,s->y,s->z,d->x,d->y,d->z,sc,dc,bptr->altl);
  	   }
!     } else
  	ForEachBond
  	   if( bptr->flag & DrawBondFlag )
             {   s = bptr->srcatom; d = bptr->dstatom;
                 if( !bptr->col )
                 {   sc = s->col;  dc = d->col;
!                } else sc = dc = bptr->col;
  
                 if( bptr->flag&WireFlag )
                 {      DrawTwinVector(s->x,s->y,s->z,d->x,d->y,d->z,sc,dc,
--- 893,991 ----
      register Group __far *group;
      register RAtom __far *aptr;
  
+     iProbeRad = (int)rint(Scale*(Real)ProbeRadius);
      if( UseShadow )
      {   if( !BucketFlag )
  	    PrepareYBucket();
  	ScanLine();
      } else if( UseClipping )
      {   ForEachAtom
! 	    if( aptr->flag&(SphereFlag|TouchFlag) )
! 		ClipSphere(aptr->x,aptr->y,aptr->z,
!                     aptr->irad+((aptr->flag&ExpandFlag)?iProbeRad:0),
!                     aptr->col);
      } else 
  	ForEachAtom
! 	    if( aptr->flag&(SphereFlag|TouchFlag) )
! 		DrawSphere(aptr->x,aptr->y,aptr->z,
!                     aptr->irad+((aptr->flag&ExpandFlag)?iProbeRad:0),
!                     aptr->col);
  }
  
+ 
  static void DisplayStars( void )
  {
      register Chain __far *chain;
      register Group __far *group;
      register RAtom __far *aptr;
  
+     iProbeRad = (int)rint(Scale*ProbeRadius);
+ 
      if( UseClipping )
      {   ForEachAtom
  	    if( aptr->flag&StarFlag )
! 		ClipStar(aptr->x,aptr->y,aptr->z,
!                   aptr->radius+(aptr->flag&ExpandFlag?ProbeRadius:0),
!                   aptr->col);
      } else 
  	ForEachAtom
  	    if( aptr->flag&StarFlag )
! 		DrawStar(aptr->x,aptr->y,aptr->z,
!                   aptr->radius+(aptr->flag&ExpandFlag?ProbeRadius:0),
!                   aptr->col);
  }
  
  
  static void DisplayWireframe( void )
  {
      register Bond __far *bptr;
+     register SurfBond __far *sbptr;
      register RAtom __far *s;
      register RAtom __far *d;
!     register int sc,dc,stmp;
! 	
!     iProbeRad = (int)rint(Scale*(Real)ProbeRadius);
  
      if( UseClipping )
      {   ForEachBond
  	   if( bptr->flag & DrawBondFlag )
             {   s = bptr->srcatom; d = bptr->dstatom;
! 
! 
! 
! 	       if( !bptr->col ) {
! 	         sc = s->col;  dc = d->col;
! 	       } else {
!                  sc = dc = bptr->col;
! 
! 
!                }
  
  	       if( bptr->flag&WireFlag )
  	       {   ClipTwinVector(s->x,s->y,s->z,d->x,d->y,d->z,sc,dc,bptr->altl);
  	       } else if( bptr->flag&CylinderFlag )
  	       {   if( bptr->irad>0 )
  	           {  ClipCylinder(s->x,s->y,s->z,d->x,d->y,d->z,
!                                    sc,dc,bptr->irad, bptr->altl, bptr->iarad);
  	           } else ClipTwinLine(s->x,s->y,s->z,d->x,d->y,d->z,
  				   sc+ColourMask,dc+ColourMask,bptr->altl);
                 } else /* bptr->flag & DashFlag */
                     ClipDashVector(s->x,s->y,s->z,d->x,d->y,d->z,sc,dc,bptr->altl);
  	   }
!     } else {
  	ForEachBond
  	   if( bptr->flag & DrawBondFlag )
             {   s = bptr->srcatom; d = bptr->dstatom;
+ 
+ 
+ 
                 if( !bptr->col )
                 {   sc = s->col;  dc = d->col;
!                } else {
!                  sc = dc = bptr->col;
! 
! 
!                }
  
                 if( bptr->flag&WireFlag )
                 {      DrawTwinVector(s->x,s->y,s->z,d->x,d->y,d->z,sc,dc,
***************
*** 1014,1019 ****
--- 999,1072 ----
  	       } else ClipDashVector(s->x,s->y,s->z,d->x,d->y,d->z,sc,dc,
                          bptr->altl);
             }
+      } 
+      if (DrawSurf && DrawAtoms)
+      ForEachSurfBond
+      {   s = sbptr->srcatom; d = sbptr->dstatom;
+ 	     if (s->flag&SelectFlag && d->flag&SelectFlag
+ 	         && !(s->flag&ExpandFlag || d->flag&ExpandFlag )) {
+ 
+ 
+ 
+          if( !sbptr->col ) {
+            sc = s->col;  dc = d->col;
+          } else {
+            sc = dc = sbptr->col;
+ 
+ 
+          }
+          SBD.rad = s->irad;
+          if (d->irad > SBD.rad) SBD.rad = d->irad;
+          if (iProbeRad > SBD.rad) SBD.rad = iProbeRad;
+          SBD.x1 = s->x;
+          SBD.y1 = s->y;
+          SBD.z1 = s->z;
+          SBD.x2 = d->x;
+          SBD.y2 = d->y;
+          SBD.z2 = d->z;
+          SBD.U[0] = SBD.x2-SBD.x1;
+          SBD.U[1] = SBD.y2-SBD.y1;
+          SBD.U[2] = SBD.z2-SBD.z1;
+          SBD.sxyz = (LScale*sbptr->sxyz)>>4;
+          SBD.c1 = sc;
+          SBD.c2 = dc;
+          SBD.u1 = (LScale*sbptr->u1)>>4;
+          SBD.u2 = (LScale*sbptr->u2)>>4;
+          SBD.wp = (LScale*sbptr->wp)>>4;
+          SBD.t1 = (LScale*sbptr->t1)>>4;
+          SBD.t2 = (LScale*sbptr->t2)>>4;
+          SBD.w1 = (LScale*sbptr->w1)>>4;
+          SBD.w2 = (LScale*sbptr->w2)>>4;
+ 
+          SBD.s0=0;
+          SBD.s1=1;
+          SBD.s2=2;
+ 
+          if (AbsFun(SBD.U[0]) > AbsFun(SBD.U[1])) {
+              SBD.s0 = 1;
+              SBD.s1 = 0;
+          }
+          if (AbsFun(SBD.U[SBD.s1]) > AbsFun(SBD.U[2])) {
+              stmp = SBD.s1;
+              SBD.s1 = SBD.s2;
+              SBD.s2 = stmp;
+          }
+          if (AbsFun(SBD.U[SBD.s0]) > AbsFun(SBD.U[SBD.s1])) {
+              stmp = SBD.s0;
+              SBD.s0 = SBD.s1;
+              SBD.s1 = stmp;
+          }
+ 
+          SBD.Us0Us1 = SBD.U[SBD.s0]*SBD.U[SBD.s1];
+          SBD.Us0Us0_Us2Us2 = SBD.U[SBD.s0]*SBD.U[SBD.s0]+SBD.U[SBD.s2]*SBD.U[SBD.s2];
+          SBD.Us1Us1_Us2Us2 = SBD.U[SBD.s1]*SBD.U[SBD.s1]+SBD.U[SBD.s2]*SBD.U[SBD.s2];
+          SBD.Us0Us0_Us1Us1_Us2Us2 = SBD.U[SBD.s0]*SBD.U[SBD.s0]+
+              SBD.U[SBD.s1]*SBD.U[SBD.s1]+SBD.U[SBD.s2]*SBD.U[SBD.s2];
+ 	     ClipSurfaceBond(s->x,s->y,s->z,d->x,d->y,d->z,
+                  sc,dc, s->irad,d->irad, iProbeRad, sbptr->altl);
+ 	   }
+      }
+ 
  }
  
  
***************
*** 1425,1431 ****
      register int irad,sc,dc;
      register int col;
  
!     irad = (int)(Scale*20);
  
      if( irad>0 )
      {   ForEachBond
--- 1478,1484 ----
      register int irad,sc,dc;
      register int col;
  
!     irad = (int)rint(Scale*20);
  
      if( irad>0 )
      {   ForEachBond
***************
*** 1452,1458 ****
  	}
  
  
!     irad = (int)(Scale*50);
      ForEachAtom
  	if( aptr->flag&NonBondFlag )
  	{   col = Shade2Colour( (aptr->flag&SelectFlag)? 1 : 0 );
--- 1505,1511 ----
  	}
  
  
!     irad = (int)rint(Scale*50);
      ForEachAtom
  	if( aptr->flag&NonBondFlag )
  	{   col = Shade2Colour( (aptr->flag&SelectFlag)? 1 : 0 );
***************
*** 1464,1473 ****
  static void RenderFrame( void )
  {
      register Chain __far *chain;
  
      if( !DisplayMode )
      {   if( DrawAtoms ) 
! 	    DisplaySpaceFill();
          if( DrawStars )
              DisplayStars();
  
--- 1517,1533 ----
  static void RenderFrame( void )
  {
      register Chain __far *chain;
+     int dwf;
+ 
+     dwf = 0;
  
      if( !DisplayMode )
      {   if( DrawAtoms ) 
!         DisplaySpaceFill();
!         if( DrawSurf ) {
!           DisplayWireframe();
!           dwf++;
!         }
          if( DrawStars )
              DisplayStars();
  
***************
*** 1475,1481 ****
  	{   if( DrawBonds ) 
              {   if( DrawDoubleBonds )
                  {   DisplayDoubleBonds();
!                 } else DisplayWireframe();
              }
  
  	    if( DrawRibbon )
--- 1535,1544 ----
  	{   if( DrawBonds ) 
              {   if( DrawDoubleBonds )
                  {   DisplayDoubleBonds();
!                 } else {
!                   if (!dwf) DisplayWireframe();
!                   dwf++;
!                 }
              }
  
  	    if( DrawRibbon )
***************
*** 1542,1547 ****
--- 1605,1612 ----
      /* Common View Elements */
      View.yskip = XRange;
      View.ymax = YRange;
+     View.fbuf = FBuffer;
+     View.dbuf = DBuffer;
  
      if( UseStereo )
      {
***************
*** 1549,1557 ****
          wide = XRange>>1;
  
          /* Create 'Left' View structure */
!         View.fbuf = FBuffer;
!         View.dbuf = DBuffer;
          View.xmax = wide;
  
          DialValue[DialRY] -= temp;
          ReDrawFlag |= RFRotateY;
--- 1614,1622 ----
          wide = XRange>>1;
  
          /* Create 'Left' View structure */
!         View.shift = 0;
          View.xmax = wide;
+         View.offmax = 2*wide*YRange;
  
          DialValue[DialRY] -= temp;
          ReDrawFlag |= RFRotateY;
***************
*** 1559,1567 ****
          RenderFrame();
  
          /* Create 'Right' View structure */
!         View.fbuf = FBuffer+wide;
!         View.dbuf = DBuffer+wide;
          View.xmax = wide;
  
          DialValue[DialRY] += temp;
          ReDrawFlag |= RFRotateY;
--- 1624,1632 ----
          RenderFrame();
  
          /* Create 'Right' View structure */
!         View.shift = wide;
          View.xmax = wide;
+         View.offmax = 2*wide*YRange;
  
          DialValue[DialRY] += temp;
          ReDrawFlag |= RFRotateY;
***************
*** 1570,1578 ****
  
      } else /* Mono */
      {   /* Create 'Mono' View structure */
!         View.fbuf = FBuffer;
!         View.dbuf = DBuffer;
          View.xmax = XRange;
          RenderFrame();
      }
  
--- 1635,1643 ----
  
      } else /* Mono */
      {   /* Create 'Mono' View structure */
!         View.shift = 0;
          View.xmax = XRange;
+         View.offmax = XRange*YRange;
          RenderFrame();
      }
  
***************
*** 1712,1735 ****
  	    }
  
  	    if( aptr->flag & (SphereFlag | StarFlag) )
! 	    {   dy = AbsFun(aptr->y-ypos);
! 		if( dy>aptr->irad ) continue;
! 		rad = LookUp[aptr->irad][dy];
  		dx = AbsFun(aptr->x-xpos);
  		if( dx>rad ) continue;
  
  		new = False;
! 		dpth = aptr->z+LookUp[rad][dx];
  		if( UseSlabPlane && (aptr->z+rad>=SlabValue) )
  		{   dz = SlabValue-aptr->z;
  		    if( SlabMode && (dz >= -rad) )
! 		    {   wide = LookUp[aptr->irad][AbsFun(dz)];
! 			if( (dy<=wide) && (dx<=(int)(LookUp[wide][dy])) )
  			{   if( SlabMode == SlabFinal )
  			    {   dpth = SliceValue;
  				new = True;
  			    } else if( SlabMode == SlabHollow )
! 			    {   dpth = aptr->z-LookUp[rad][dx];
  				new = !IdentFound || (dpth>IdentDepth);
  			    } else if( SlabMode != SlabHalf )
  			    {   /* SlabClose, SlabSection */
--- 1777,1804 ----
  	    }
  
  	    if( aptr->flag & (SphereFlag | StarFlag) )
! 	    {   int xrad;
! 
!                 xrad = aptr->irad;
!                 if (aptr->flag&ExpandFlag) xrad+=iProbeRad;
!                 dy = AbsFun(aptr->y-ypos);
! 		if( dy > xrad ) continue;
! 		rad = pythag(xrad,dy);
  		dx = AbsFun(aptr->x-xpos);
  		if( dx>rad ) continue;
  
  		new = False;
! 		dpth = aptr->z+pythag(rad,dx);
  		if( UseSlabPlane && (aptr->z+rad>=SlabValue) )
  		{   dz = SlabValue-aptr->z;
  		    if( SlabMode && (dz >= -rad) )
! 		    {   wide = pythag(aptr->irad,AbsFun(dz));
! 			if( (dy<=wide) && (dx<=pythag(wide,dy)) )
  			{   if( SlabMode == SlabFinal )
  			    {   dpth = SliceValue;
  				new = True;
  			    } else if( SlabMode == SlabHollow )
! 			    {   dpth = aptr->z-pythag(rad,dx);
  				new = !IdentFound || (dpth>IdentDepth);
  			    } else if( SlabMode != SlabHalf )
  			    {   /* SlabClose, SlabSection */
***************
*** 2146,2151 ****
--- 2215,2221 ----
      DrawBonds = False;  MaxBondRadius = 0;
      DrawStars = False;
      DrawRibbon = False;
+     DrawSurf = False;
  
      SlabMode = SlabClose;
      UseSlabPlane = False;
*** render.h	2004/05/07 19:46:16	1.1
--- render.h	2005/01/16 20:25:16
***************
*** 135,141 ****
  
  #define ColBits          24
  
! #define VOXORDER       21
  #define VOXORDER2      (VOXORDER*VOXORDER)
  #define VOXSIZE        (VOXORDER2*VOXORDER)
  
--- 141,150 ----
  
  #define ColBits          24
  
! /* To handle larger molecules efficiently
!    use VOXORDER 32 or larger.  To save space
!    use VOXORDER 21 or smaller */
! #define VOXORDER       32
  #define VOXORDER2      (VOXORDER*VOXORDER)
  #define VOXSIZE        (VOXORDER2*VOXORDER)
  
***************
*** 175,180 ****
--- 184,191 ----
  int FBClear;
  
  
+ 
+ 
  Card __far *ColConst;
  #if defined(IBMPC) || defined(APPLEMAC)
  void __far * __far *HashTable;
***************
*** 187,192 ****
--- 198,204 ----
  Byte Array[MAXTABLE];
  #endif
  
+ 
  #else
  extern int UseDepthCue;
  extern int UseStereo,StereoView;
***************
*** 216,221 ****
--- 228,235 ----
  extern int FBClear;
  
  
+ 
+ 
  extern Card __far *ColConst;
  #if defined(IBMPC) || defined(APPLEMAC)
  extern void __far * __far *HashTable;
***************
*** 227,234 ****
--- 241,262 ----
  extern Byte *LookUp[MAXRAD];
  extern Byte Array[MAXTABLE];
  #endif
+ 
+ 
  #endif
  
+ #define pythag(h,x) \
+            ((h)<MAXRAD? \
+              (int)LookUp[(h)][(x)]: \
+              (int)(.5+(sqrt((double)((h)*(h)-(x)*(x))))))
+ #define apythag(h,x) \
+            ((h)<MAXRAD/2? \
+              (int)LookUp[(h)][(x)]: \
+              (int)(.5+(sqrt((double)((h)*(h)-(x)*(x))))))
+ #define colconst(r) \
+      ((r)<MAXRAD? \
+        ColConst[(r)] : \
+        (Card)(((Card)ColourDepth<<ColBits)/((int)(LightLength*(r)+4))))
  
  void ClearBuffers( void );
  void ReSizeScreen( void );
*** repres.c	2004/05/07 19:46:16	1.1
--- repres.c	2005/01/16 20:25:17
***************
*** 152,158 ****
  #endif
  
  /* These define light source position */
- #define LightDot(x,y,z)  ((x)+(y)+(z)+(z))
  #define LightLength      RootSix
  
  
--- 155,160 ----
***************
*** 818,824 ****
          {   aptr = item->data;
              if( !ProbeRadius )
              {   rad = ElemVDWRadius(aptr->elemno);
!             } else rad = ProbeRadius;
              rad = rad*rad;
   
              /* Optimized Test! */
--- 820,826 ----
          {   aptr = item->data;
              if( !ProbeRadius )
              {   rad = ElemVDWRadius(aptr->elemno);
!             } else rad = ElemVDWRadius(aptr->elemno)+ProbeRadius;
              rad = rad*rad;
   
              /* Optimized Test! */
***************
*** 920,926 ****
   
      if( SolventDots || !ProbeRadius )
      {   rad = ElemVDWRadius(elem);
!     } else rad = ProbeRadius;
   
      count = (int)(((Long)density*rad*rad)/((Long)250*250));
      ptr = (DotVector __far*)_fmalloc(count*sizeof(DotVector));
--- 922,928 ----
   
      if( SolventDots || !ProbeRadius )
      {   rad = ElemVDWRadius(elem);
!     } else rad = ElemVDWRadius(elem)+ProbeRadius;
   
      count = (int)(((Long)density*rad*rad)/((Long)250*250));
      ptr = (DotVector __far*)_fmalloc(count*sizeof(DotVector));
***************
*** 932,938 ****
          temp = rad + ProbeRadius;
      } else probe = NULL;
   
!     equat = (int)sqrt(PI*count);
      if( !(vert=equat>>1) )
          vert = 1;
   
--- 934,940 ----
          temp = rad + ProbeRadius;
      } else probe = NULL;
   
!     equat = (int)rint(sqrt(PI*count));
      if( !(vert=equat>>1) )
          vert = 1;
   
***************
*** 940,946 ****
      for( j=0; (i<count) && (j<vert); j++ )
      {   p = (PI*j)/(Real)vert;
          z = cos(p);  xy = sin(p);
!         horz = (int)(equat*xy);
          if( !horz ) horz = 1;
   
          for( k=0; (i<count) && (k<horz); k++ )
--- 942,948 ----
      for( j=0; (i<count) && (j<vert); j++ )
      {   p = (PI*j)/(Real)vert;
          z = cos(p);  xy = sin(p);
!         horz = (int)rint(equat*xy);
          if( !horz ) horz = 1;
   
          for( k=0; (i<count) && (k<horz); k++ )
***************
*** 948,960 ****
              x = xy*sin(q);
              y = xy*cos(q);
   
!             ptr[i].dx = (int)(rad*x);
!             ptr[i].dy = (int)(rad*y);
!             ptr[i].dz = (int)(rad*z);
              if( probe )
!             {   probe[i].dx = (int)(temp*x);
!                 probe[i].dy = (int)(temp*y);
!                 probe[i].dz = (int)(temp*z);
              }
              i++;
          }
--- 950,962 ----
              x = xy*sin(q);
              y = xy*cos(q);
   
!             ptr[i].dx = (int)rint(rad*x);
!             ptr[i].dy = (int)rint(rad*y);
!             ptr[i].dz = (int)rint(rad*z);
              if( probe )
!             {   probe[i].dx = (int)rint(temp*x);
!                 probe[i].dy = (int)rint(temp*y);
!                 probe[i].dz = (int)rint(temp*z);
              }
              i++;
          }
***************
*** 970,977 ****
      register int i;
   
      for( i=0; i<MAXELEMNO; i++ )
!         if( ElemDots[i].count )
              _ffree( ElemDots[i].dots );
      _ffree( ElemDots );
  }
   
--- 972,983 ----
      register int i;
   
      for( i=0; i<MAXELEMNO; i++ )
!         if( ElemDots[i].count ) {
              _ffree( ElemDots[i].dots );
+             if ( ElemDots[i].probe ) {
+               _ffree( ElemDots[i].probe );
+             }
+         }
      _ffree( ElemDots );
  }
   
***************
*** 1096,1104 ****
      register int i;
      register int Cenx,Ceny,Cenz;
      
!     Cenx=(int)(CenX*MatX[0]+CenY*MatX[1]+CenZ*MatX[2]);
! 	Ceny=(int)(CenX*MatY[0]+CenY*MatY[1]+CenZ*MatY[2]);
! 	Cenz=(int)(CenX*MatZ[0]+CenY*MatZ[1]+CenZ*MatZ[2]);
  
   
      for( ptr=DotPtr; ptr; ptr=ptr->next )
--- 1102,1110 ----
      register int i;
      register int Cenx,Ceny,Cenz;
      
!     Cenx=(int)rint(CenX*MatX[0]+CenY*MatX[1]+CenZ*MatX[2]);
!     Ceny=(int)rint(CenX*MatY[0]+CenY*MatY[1]+CenZ*MatY[2]);
!     Cenz=(int)rint(CenX*MatZ[0]+CenY*MatZ[1]+CenZ*MatZ[2]);
  
   
      for( ptr=DotPtr; ptr; ptr=ptr->next )
***************
*** 1107,1117 ****
              y = ptr->ypos[i];
              z = ptr->zpos[i];
   
!             xi = (int)(x*MatX[0]+y*MatX[1]+z*MatX[2])+XOffset-Cenx;
              if( XValid(xi) )
!             {   yi = (int)(x*MatY[0]+y*MatY[1]+z*MatY[2])+YOffset-Ceny;
                  if( YValid(yi) )
!                 {   zi = (int)(x*MatZ[0]+y*MatZ[1]+z*MatZ[2])+ZOffset-Cenz;
                      if( ZValid(zi) && ZBack(zi) )
                          PlotDeepPoint(xi,yi,zi,ptr->col[i]);
                  }
--- 1113,1123 ----
              y = ptr->ypos[i];
              z = ptr->zpos[i];
   
!             xi = (int)rint(x*MatX[0]+y*MatX[1]+z*MatX[2])+XOffset-Cenx;
              if( XValid(xi) )
!             {   yi = (int)rint(x*MatY[0]+y*MatY[1]+z*MatY[2])+YOffset-Ceny;
                  if( YValid(yi) )
!                 {   zi = (int)rint(x*MatZ[0]+y*MatZ[1]+z*MatZ[2])+ZOffset-Cenz;
                      if( ZValid(zi) && ZBack(zi) )
                          PlotDeepPoint(xi,yi,zi,ptr->col[i]);
                  }
*** repres.h	2004/05/07 19:46:16	1.1
--- repres.h	2005/01/16 20:25:16
***************
*** 136,141 ****
--- 139,145 ----
  int CartoonHeight;
  int SolventDots;
  int ProbeRadius;
+ int iProbeRad;
  
  int SurfaceChainsFlag;
  int DotDensity;
***************
*** 152,157 ****
--- 156,162 ----
  
  extern int CartoonHeight;
  extern int ProbeRadius;
+ extern int iProbeRad;
  extern int SolventDots;
  
  extern int SurfaceChainsFlag;
*** tokens.c	2004/05/07 19:46:16	1.1
--- tokens.c	2005/01/16 20:25:17
***************
*** 912,917 ****
--- 915,921 ----
          MOL2                 Mol2Tok
          MOLECULE             MoleculeTok
          MOLSCRIPT            MolScriptTok
+         MOLSURF		     MolSurfTok
          MONITOR              MonitorTok
          MONITORS             MonitorTok
          MONO                 MonoTok
***************
*** 964,969 ****
--- 968,975 ----
  		                return( MoleculeTok );
                      } else if( !strcmp(ptr,"LSCRIPT") ) {
                          return( MolScriptTok );
+                     } else if( !strcmp(ptr,"LSURF") ) {
+                         return( MolSurfTok );
                      } else if( !strcmp(ptr,"NITOR") ) {
                          return( MonitorTok );
                      } else if( !strcmp(ptr,"NITORS") ) {
*** tokens.h	2004/05/07 19:46:16	1.1
--- tokens.h	2005/01/16 20:25:16
***************
*** 126,131 ****
--- 129,135 ----
  #define LoadTok        276
  #define LoopTok        277
  #define MoleculeTok    278
+ #define MolSurfTok     255     // pzh: this may have to be changed 
  #define MonitorTok     279
  #define MoveTok        280
  #define PrintTok       281
